import os
import sys
import array as arr
import collections

from collections import Counter


def filename_list_generator(file_to_open):
    word = ""
    with open(file_to_open, "r") as file:
        file.read(0)
        for line in file:
            for word in line.split(" "):
                if word.endswith(".nc") or word.endswith("_nc_files"):
                    yield word
                    break

def configname_list_generator(file_to_open):
    word = ""
    with open(file_to_open, "r") as file:
        file.read(0)
        for line in file:
            for word in line.split(" "):
                if "config_" in word:
                    yield word
                    break

def foldername_list_generator(file_to_open):
    word = ""
    
    with open(file_to_open, "r") as file:
        file.read(0)
        for line in file:
            for word in line.split(" "):
                if word.startswith("test_"):
                    yield word
                    break

def result_list_generator(file_to_open):
    word = ""
    with open(file_to_open, "r") as file:
        file.read(0)
        for line in file:
            for word in line.split(" "):
                if word == '-1' or word == '0' or word == '1':
                    yield(word)
                    break
                
             

def main():

    if os.path.exists('plein_report.txt') :
        file_to_open="plein_report.txt"
    else :
        file_to_open="plein_report_example.txt"

    folderlist=[]
    for x in foldername_list_generator(file_to_open):
        folderlist.append(x)

    configlist=[]
    for x in configname_list_generator(file_to_open):
        configlist.append(x)
    
    filelist=[]
    for x in filename_list_generator(file_to_open):
        filelist.append(x)

    resultlist=[]
    for x in result_list_generator(file_to_open):
        resultlist.append(x)

    total_records = len(resultlist)

    c = Counter(folderlist)
    nb_level1 = len(c)
    
    my_struncture = dict()

    for i in range(nb_level1):
        my_key1 = list(c.keys())[i] # algo_name
        my_struncture.update({my_key1 : dict()})
        min_range=-1
        for index in range(total_records) :
            if my_key1 == folderlist[index] :
                if min_range == -1 :
                    min_range = index
                    max_range = index
                else :
                    max_range = index
        cc = Counter(configlist[min_range: max_range+1])
        nb_level2 = len(cc)        
        
        for j in range(nb_level2) :
            my_key2 = list(cc.keys())[j] #config_name
            my_struncture[my_key1].update({my_key2:dict()})
            min_range = -1
            for index in range(total_records) :
                if my_key2 == configlist[index] :
                    if min_range == -1 :
                        min_range = index
                        max_range = index
                    else :
                        max_range = index

            ccc = Counter(filelist[min_range: max_range+1])
            nb_level3 = len(ccc)            

            for k in range(nb_level3) :
                my_key3 = list(ccc.keys())[k] #filename
                
                min_range = -1
                for index in range(total_records) :
                    if my_key3 == filelist[index] :
                        if min_range == -1 :
                            min_range = index
                            max_range = index
                        else :
                            max_range = index
                my_struncture[my_key1][my_key2].update({my_key3:resultlist[min_range]})



    nb_algo = len(my_struncture)

    for x in range(nb_algo) :
        algo_name = list(my_struncture.keys())[x]
        nb_config = len(my_struncture[algo_name])
        for y in range(nb_config) :
            config_name = list(my_struncture[algo_name].keys())[y]
            nb_file = len(my_struncture[algo_name][config_name])

    
    algo_names=list(my_struncture.keys())

    nb_files = [0]*nb_algo
    nb_configs = [0]*nb_algo

    for x in range(nb_algo) :
        nb_files[x] = len(my_struncture[list(my_struncture.keys())[x]][list(my_struncture[list(my_struncture.keys())[x]].keys())[0]])
        nb_configs[x] = len(my_struncture[list(my_struncture.keys())[x]])

    
    level1_answer=1
    level2_answer=[1]*nb_algo

    level3_answer = [[]]*nb_algo
    for x in range(nb_algo) :
        level3_answer[x] = [1]*nb_configs[x]

    level4_answer = [[[]]]*nb_algo
    for x in range(nb_algo) :
        level4_answer[x] = [[]]*nb_configs[x]
        for y in range(nb_configs[x]) :
            level4_answer[x][y] = [1]*nb_files[x]
            for z in range(nb_files[x]) :
                x_dict = my_struncture
                y_dict = x_dict[list(x_dict.keys())[x]]
                z_dict = y_dict[list(y_dict.keys())[y]]
                level4_answer[x][y][z] = int(z_dict[list(z_dict.keys())[z]])

    index=0
    for x in range(nb_algo):
        for y in range(len(level3_answer[x])):
            for z in range(len(level4_answer[x][y])):
                level3_answer[x][y] = min(level4_answer[x][y][z], level3_answer[x][y])
            index+=1

    index=0
    for x in range(len(level2_answer)):
        for y in range(len(level3_answer[x])):
            level2_answer[x] = min(level2_answer[x], level3_answer[x][y])
        index+=1

    for x in range(len(level2_answer)):
        level1_answer = min(level1_answer, level2_answer[x])

    ans_dict = {-1: 'Failed', 0: 'Initialized', 1: 'Passed'}

    algo_list = list(my_struncture.keys())


    config_list=[]
    for x in range(nb_algo) :
        my_list = list(my_struncture[list(my_struncture.keys())[x]].keys())
        for y in range(len(my_list)) :
            config_list.append(my_list[y])


    file_list=[]
    for x in range(nb_algo) :
        l = list(my_struncture.keys())[x]
        ll = list(my_struncture[l].keys())[0]
        lll = list(my_struncture[l][ll].keys())
        for y in range(len(lll)) :
            file_list.append(lll[y])

    
    old_config_list=config_list[:]
    for x in range(len(config_list)) :
        word = config_list[x]
        new_word=''
        for i in range(len(word)) :
            if word[i]=="@" :
                new_word = word[i+1:]
                break
        # old_config_list.append(new_word)
        old_config_list[x]=new_word
        word = new_word.replace("config_", "CONFIG: ")
        new_word = word.replace("_", " ")
        config_list[x] = new_word


    for x in range(len(file_list)) :
        word = file_list[x]
        new_word=''
        for i in range(len(word)) :
            if word[i]=="@" :
                new_word = word[i+1:]
                break
        file_list[x] = new_word

    for x in range(len(file_list)) :
        word = file_list[x]
        new_word=''
        for i in range(len(word)) :
            if word[i]=="@" :
                new_word = word[i+1:]
                break
        file_list[x] = new_word


    f=open("xios_table.html", "w")
    f.write("<html>\n")
    f.write("<head>\n")
    f.write("</head>\n")
    f.write("<body>\n")
    f.write("   <table id=\"xiostable\">\n")
    f.write("       <thead></thead>\n")
    f.write("       <tfoot></tfoot>\n")
    f.write("       <tbody>\n")
    f.write("           <tr class=\"level0\" style=\"background-color:#85c1e9;font-size:1em;\" >\n")
    f.write("               <td>src : "+file_to_open+"</tb>\n")
    f.write("               <td></td>\n")
    f.write("               <td></td>\n")
    f.write("               <td></td>\n")
    f.write("               <td></td>\n")
    f.write("               <td></td>\n")
    f.write("               <td></td>\n")
    f.write("               <td></td>\n")
    f.write("           </tr>\n")
    f.write("           <tr class=\"level1\" style=\"background-color:#85c1e9;font-size:1.6em;\" >\n")
    f.write("               <td>XIOS Unit tests <span id=\"icon_level1_1\" onclick=\"level1_unfold();\" style=\"display:inline\">&#128317;</span>\n")
    f.write("                                   <span id=\"icon_level1_2\" onclick=\"level1_fold();\" style=\"display:none\">&#128316;</span></td>\n")
    f.write("               <td></td>\n")
    f.write("               <td></td>\n")
    f.write("               <td></td>\n")
    f.write("               <td style=\"border-left: 0px\" class=\"testanswer\">"+ ans_dict[level1_answer]+"</td>\n")
    f.write("               <td></td>\n")
    f.write("               <td></td>\n")
    f.write("               <td></td>\n")
    f.write("           </tr>\n")
        
    
    x_offset = 0
    y_offset = 0
    for x in range(nb_algo):
        f.write("           <tr class=\"level2\" data-algo-type=\""+algo_list[x]+"\" style=\"display:none;background-color:#aed6f1;font-size:1.4em;\">\n")
        f.write("               <td></td>\n")
        f.write("               <td>"+algo_list[x]+" <span id=\"icon_level2_"+algo_list[x]+"_1\" onClick=\"level2_unfold(\'"+algo_list[x]+"\');\" style=\"display:inline\">&#128317;</span>\n")
        f.write("                                    <span id=\"icon_level2_"+algo_list[x]+"_2\" onClick=\"level2_fold(\'"+algo_list[x]+"\');\" style=\"display:none\">&#128316;</span></td>\n")
        f.write("               <td><div class=\"dropdown\"><button class=\"dropbtn\">&#128270;</button>\n")
        f.write("               <div class=\"dropdown-content\">\n")
        f.write("               <a href=\"#\" onclick=\"show_param_"+algo_list[x]+"()\">show user_params.def</a>\n")
        f.write("               </div></div></td>\n")
        f.write("               <td> </td>\n")
        f.write("               <td> </td>\n")
        f.write("               <td class=\"testanswer\">"+ans_dict[level2_answer[x]]+"</td>\n")
        f.write("               <td> </td>\n")
        f.write("               <td> </td>\n")
        f.write("           </tr>\n")
        
        for y in range(nb_configs[x]):
            f.write("           <tr class=\"level3_"+algo_list[x]+"\" data-algoconfig-type=\""+algo_list[x]+"_"+old_config_list[y_offset]+"\" style=\"display:none;background-color:#d6eaf8;font-size:1.2em;\">\n")
            f.write("               <td></td>\n")
            f.write("               <td></td>\n")
            f.write("               <td>"+config_list[y_offset]+" <span id=\"icon_level3_"+algo_list[x]+"_"+old_config_list[y_offset]+"_1\" onClick=\"level3_unfold(\'"+algo_list[x]+"_"+old_config_list[y_offset]+"\');\" style=\"display:inline\">&#128317;</span>\n")
            f.write("                                             <span id=\"icon_level3_"+algo_list[x]+"_"+old_config_list[y_offset]+"_2\" onClick=\"level3_fold(\'"+algo_list[x]+"_"+old_config_list[y_offset]+"\');\" style=\"display:none\">&#128316;</span></td>\n")
            f.write("               <td><div class=\"dropdown\"><button class=\"dropbtn\">&#128270;</button>\n")
            f.write("               <div class=\"dropdown-content\">\n")
            f.write("               <a href=\"#\" onclick=\"show_param_"+algo_list[x]+"_config("+repr(old_config_list[y_offset])+")\">show all_param.def</a>\n")
            f.write("               <a href=\"#\" onclick=\"show_user_param_"+algo_list[x]+"_config("+repr(old_config_list[y_offset])+")\">show user_param.def</a>\n")
            f.write("               </div></div></td>\n")
            y_position=y_offset
            y_offset+=1
            f.write("               <td></td>\n")
            f.write("               <td></td>\n")
            f.write("               <td class=\"testanswer\">"+ ans_dict[level3_answer[x][y]]+"</td>\n")
            f.write("               <td></td>\n")
            f.write("           </tr>\n")

            for z in range(nb_files[x]):
                f.write("           <tr class=\"level4_"+algo_list[x]+"_"+old_config_list[y_position]+"\" style=\"display:none;background-color:#ebf5fb;\">\n")
                f.write("               <td></td>\n")
                f.write("               <td></td>\n")
                f.write("               <td></td>\n")
                f.write("               <td>"+file_list[x_offset+z]+"</td>\n")
                f.write("               <td></td>\n")
                f.write("               <td></td>\n")
                f.write("               <td></td>\n")
                f.write("               <td class=\"testanswer\">"+ ans_dict[level4_answer[x][y][z]]+"</td>\n")
                f.write("            </tr>\n")

        x_offset = x_offset+nb_files[x]
    
    f.write("       </tbody>\n")
    f.write("   </table>\n")
    f.write("<script>\n")
    f.write("   var ans = document.getElementsByClassName('testanswer')\n")
    f.write("   for (var i = 0; i < ans.length; i++) {\n")
    f.write("       var cell = ans[i]\n")
    f.write("       if (cell.textContent == 'Passed') {\n")
    f.write("           cell.classList.add('green') }\n")
    f.write("       else if (cell.textContent == 'Failed') {\n")
    f.write("           cell.classList.add('red') }\n")
    f.write("       else if (cell.textContent == 'Initialized') {\n")
    f.write("           cell.classList.add('goldenrod') }\n")
    f.write("   }\n")

    f.write("\n\n")
   
    f.write("</script>\n")

    f.write("</body>\n")
    f.write("</html>\n")



    f.close()

    
if __name__== "__main__":
  main()


